markup.push({

	"SetInspectorPanel":
    {
        nsClass: "GXSettingsView",
        gxCanDrawSubviewsIntoLayer: true,
		gxIntrinsicWidth: -1,
		gxIntrinsicHeight: -1,
        gxWantsLayer: true,
        axIsIgnored: false,
        axRoleDescription: "Set Inspector",
        axHelp: "Inspect and edit settings of a selected Set",
        gxLayout: [

            "V:|-12-[title(21)]-14-[setNotes]-10-[notesPanel(200)]-7-[midiArea]",
            "H:|-12-[titleLabel(55)]-8-[title]-15-|&alignBaseline", 
            "H:[titleLabel]-5-[titleFrame]-12-|",
            "V:|-10-[titleFrame(25)]",
			"H:|-12-[setNotes]-12-|",
        ],
        gxChildViews: {
            "titleFrame": {
                nsClass: "GXDrawView",
				gxIntrinsicWidth: -1, // Very important for split view resizing - esp after system theme changes
                gxBackPainter: {
                    nsClass: "GXRoundRectPainter",
                    gxCornerRadius: 3.5,
                    gxStrokeWidth: 0.5,
                    gxFrameColor: "name:tertiary",
                },
            },
            "title": {
                "+": "TextField",
                gxValueKeyPath : "tileSet.setTitle",
                gxDisableOnKey : "selectedSet",
                gxLabelTemplate: "InspectorLabel.left.secondary.size11",
                gxBaselineOffset: -5,
				gxIntrinsicWidth: -1, // Very important for split view resizing - esp after system theme changes
                gxLabelText: "Set Name",
                gxEditingKeyPath : "tileSet.editingTitle",
                gxEditable: true,
                axTitle: "Set Name",
                axDescription: "The name of the currently selected set."
            },
            "midiArea" : { "+" : "MidiLearnSection"},
            "setNotes": {
                "+": "InspectorLabel.left.secondary.size11",
				gxIntrinsicWidth: -1,
                gxDefaultValue: "Set Notes",
                axTitle: "Set Notes",
                axDescription: "Notes for the current selected set"
            },
            "notesPanel" : {
                // panel shown for the notes tab
                "+": "NotesPanel",
            },
        }
    },

});
